//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "MixKeyImptDlgs.h"
#include "MixProbWins.h"
#include "Mixmaster.h"
#include "pgpbuffers.h"
#include "Global.h"
#include "HelpDlgs.h"
#include "View.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TMixKeyImptDlg *MixKeyImptDlg;
const AnsiString MixNoKeysFoundAtAll = "...NO KEYS FOUND AT ALL!";
const AnsiString MixLoading = "Loading...";
//---------------------------------------------------------------------------
bool __fastcall ImportMixmasterKeys(TForm *Owner, TMixKeyList *keylist,
   TMixKeyList *ImpKeys, TMixKeyList *DupKeys,AnsiString &ImportDir)
{
   MixKeyImptDlg = new TMixKeyImptDlg(Owner,keylist,ImpKeys,DupKeys,ImportDir);
   MixKeyImptDlg->ShowModal();
   bool ok = MixKeyImptDlg->ModalResult==mrOk && (ImpKeys->Count || DupKeys->Count);
   delete MixKeyImptDlg;
   return ok;
}
//---------------------------------------------------------------------------
__fastcall TMixKeyImptDlg::TMixKeyImptDlg(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TMixKeyImptDlg::TMixKeyImptDlg(TComponent* Owner, TMixKeyList *Keylist,
   TMixKeyList *ImpKeys, TMixKeyList *DupKeys, AnsiString &ImportDir)
   : TForm(Owner)
{
   CenterDialog(this);
   impdir = &ImportDir;
   OpenDialog->InitialDir = *impdir;
   OpenDialog->Filter = "Mixmaster key files (*.mix)|*.mix|All files (*.*)|*.*";
   OpenDialog->DefaultExt = ".mix";
   OpenDialog->FileName = "";
   ComboBox1->Items->Text = "Import Keys to Pubring.mix";
   ComboBox1->ItemIndex = 0;
   keylist = Keylist;
   implist = ImpKeys;
   implist->Clear();
   duplist = DupKeys;
   duplist->Clear();
   dislist = new TMixKeyList();
   cap = Caption;
   nokeysfoundatall = MixNoKeysFoundAtAll;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyImptDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   int i,p;
   if (ModalResult==mrCancel)
   {
      if (ImportBtn->Enabled)
      {
          switch (MsgBoxHwnd(Handle,
            "You have good new keys!  Save them now?","Confirm",MB_YESNOCANCEL))
          {
             case IDCANCEL: CanClose=false; return;
             case IDNO: return;
          }
      }
      else return;
   }

   if (ImportBtn->Enabled)
   {
      if (MsgBoxHwnd(Handle,"Import selected keys now?","Confirm",MB_OKCANCEL)==IDCANCEL)
      {
         CanClose = false;
         return;
      }
      Caption = "Importing...";
      i=0; while (i<implist->Count)
      {
         p=ListBox1->Items->IndexOf(implist->Strings[i]);
         if (p>=0 && !ListBox1->Selected[p]) implist->DeleteKey(i);
         else i++;
      }
      i=0; while (i<duplist->Count)
      {
         p=ListBox1->Items->IndexOf(duplist->Strings[i]);
         if (p>=0 && !ListBox1->Selected[p]) duplist->DeleteKey(i);
         else i++;
      }
   }
}
//---------------------------------------------------------------------------
__fastcall TMixKeyImptDlg::~TMixKeyImptDlg()
{
   delete dislist;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyImptDlg::ClipBtnClick(TObject *Sender)
{
   if (MsgBoxHwnd(Handle,"Import keys from the clipboard?","Confirm",MB_OKCANCEL)==IDOK)
   {
      RichEdit1->Clear();
      ListBox1->Clear();
      ListBox1->BringToFront();

      flash=0; Timer1->Enabled = true;
      TStringList *clip = new TStringList();
      clip->Text = MixPasteFromClipboard();
      ImportKeys("Clipboard",clip->Text);
      Timer1->Enabled = false;

      if (RichEdit1->Lines->Count &&
          RichEdit1->Lines->Strings[0].Pos("Clipboard"+nokeysfoundatall)>0)
      {
         RichEdit1->Lines->Add("");
         RichEdit1->Lines->Add("Clipboard Contents--------------------------------------");
         RichEdit1->Lines->AddStrings(clip);
      }
      delete clip;
   }
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyImptDlg::FileBtnClick(TObject *Sender)
{
   if (OpenDialog->Execute())
   {
      RichEdit1->Clear();
      ListBox1->Clear();
      ListBox1->BringToFront();

      flash=0; Timer1->Enabled = true;
      TStringList *keys = new TStringList();
      keys->LoadFromFile(OpenDialog->FileName);
      AnsiString filename=ExtractFileName(OpenDialog->FileName);
      ImportKeys(filename,keys->Text);
      Timer1->Enabled = false;

      if (RichEdit1->Lines->Count &&
          RichEdit1->Lines->Strings[0].Pos(nokeysfoundatall)>0)
      {
         RichEdit1->BringToFront();
         RichEdit1->Lines->Add("");
         RichEdit1->Lines->Add(filename+" Contents-----------------------------------------------");
         RichEdit1->Lines->AddStrings(keys);
      }
      delete keys;

     *impdir = ExtractFilePath(OpenDialog->FileName);
      OpenDialog->InitialDir = *impdir;
      ActiveControl = Panel1;
   }
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyImptDlg::ImportKeys(AnsiString Name, AnsiString Ascii)
{
   implist->Clear();
   duplist->Clear();
   dislist->Clear();
   ListBox1->Clear();
   RichEdit1->Clear();
   Caption = "";//MixLoading;

   //int newcnt=0,dupcnt=0,discnt=0;
   AnsiString s,mshort,curdesc,desc,keytext,orglines=Ascii;
   TStringList *keys = new TStringList();
   TStringList *key = new TStringList();
   ImportBtn->Enabled = false;
   keys->Text = Ascii;

   SetRedraw(Panel1,0);
   for (int i=0; i<keys->Count; i++)
   {
      if (keys->Strings[i]=="- "+BeginMixKey) keys->Strings[i] = BeginMixKey; else
      if (keys->Strings[i]=="- "+EndMixKey) keys->Strings[i] = EndMixKey;
   }
   while (keys->Count>2 && keys->Strings[2]!=BeginMixKey) 
      keys->Delete(0);
   while (keys->Count && keys->Strings[keys->Count-1]!=EndMixKey)
      keys->Delete(keys->Count-1);

   TMixKeyList *probs = new TMixKeyList(mprobtxt);
   while (MixGetNextKey(desc,key,keys)) // in mixmaster.cpp
   {
      bool dis=false,dup=false;
      // is the key already in type2
      if (keylist->IndexOf(desc)>=0 || probs->IndexOf(desc)>=0)
      {
         dislist->AddKey(desc,key);
         dis = true;
      }
      // No? Is the remailer shortname in type2
      if (!dis)
      {
         mshort = GetToken(0,desc," ");
         for (int i=0; i<keylist->Count; i++)
         {
            if (mshort==GetToken(0,keylist->Strings[i]," "))
            {
               duplist->AddKey(desc,key);
               dup = true;
               break;
            }
         }
      }
      // if neither above this is a new key
      if (!dis && !dup)
      {
         implist->AddKey(desc,key);
      }
   }
   delete probs;

   ListBox1->Clear();
   if (implist->Count)
   {
      for (int i=0; i<implist->Count; i++)
         ListBox1->Items->Add(implist->Strings[i]);
   }
   if (duplist->Count)
   {
      for (int i=0; i<duplist->Count; i++)
         ListBox1->Items->Add(duplist->Strings[i]);
   }
   if (ListBox1->Items->Count)
   {
      for (int i=0; i<ListBox1->Items->Count; i++)
         ListBox1->Selected[i] = true;
      ImportBtn->Enabled = true;
      ListBox1->BringToFront();
      ListBox1->TopIndex = 0;
   }
   else if (dislist->Count) RichEdit1->Lines->Add(Name+"...NO NEW KEYS");
   else RichEdit1->Lines->Add(Name+nokeysfoundatall);

   while (flash<4) AppProcessMessages();
   Timer1->Enabled = false;

   if (!ImportBtn->Enabled) RichEdit1->BringToFront();
   int total = implist->Count+duplist->Count;
   Caption = cap+"..."+s(total)+" key"+(total==1?"":"s");
   SetRedraw(Panel1,1);
   delete keys;
   delete key;
   MyBeep(MB_OK);
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyImptDlg::Timer1Timer(TObject *Sender)
{
   if (Caption.IsEmpty()) Caption = MixLoading;
   else Caption = "";
   flash++;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyImptDlg::HelpBtnClick(TObject *Sender)
{
   OpenHelp("MixmasterKeysImp","Mixmaster Keys","");
}
//---------------------------------------------------------------------------
